void * kmalloc(int i)
{
    return 0;
}

void  kfree(void* p)
{
    return;
}

typedef struct console
{
    int x;
    int y;
    char * video;
    struct console * prev;
    struct console * suiv;
    int numero;
} console;

console * Console;
console * derniere_console_utilisee;

void init_console()
{
    Console = (console*)kmalloc(sizeof(console));
    Console->x=1;
    Console->y=1;
    Console->video=(char*)kmalloc(2000);
    Console->prev=Console;
    Console->suiv=Console;
    Console->numero=0;
    derniere_console_utilisee=Console;
}

static int get_first_libre(console ** prevnew)
{
    console * c;
    int i=1;
    c=Console;
    c=c->suiv;
    while(i==(c->numero))
    {
	i++;
	c=c->suiv;
    }
    (*prevnew)=c->prev;
    return i;
}
	

int add_console()
{
    int i;
    console * curr;
    console * prev;
    console * suiv;
    i=get_first_libre(&prev);
    suiv=prev->suiv;
    curr=(console*)kmalloc(sizeof(console));
    curr->x=1;
    curr->y=1;
    curr->video=(char*)kmalloc(2000);
    curr->prev=prev;
    curr->suiv=suiv;
    curr->numero=i;
    prev->suiv=curr;
    suiv->prev=curr;
    return i;
}


static console * get_console(int i)
{
    console * c = Console;
    if ((derniere_console_utilisee->numero)==i) return derniere_console_utilisee;
    if (i==0) return Console;
    c=c->suiv;
    while ((c->numero)!=0)
    {
	if ((c->numero)==i) return c;
	c=c->suiv;
    }
    return 0;
}
    

int del_console(int i)
{
    console * c;
    if (i==0) return -1;
    c=get_console(i);
    if (c==0) return -1;
    kfree(c->video);
    (c->prev->suiv)=c->suiv;
    (c->suiv->prev)=c->prev;
    if (derniere_console_utilisee==c) derniere_console_utilisee = c->suiv;
    kfree(c);
    return 0;
}

int clear_console(int i)
{
    console * c;
    int j;
    c=get_console(i);
    if (c==0) return -1;
    derniere_console_utilisee = c;
    for(j=0;j<2000;j++)
    {
	c->video[j]=' ';
    }
    c->x=0;
    c->y=0;
    return 0;
}

int set_console_xy(int i,int x,int y)
{
    console * c;
    c=get_console(i);
    if (c==0) return -1;
    derniere_console_utilisee = c;
    c->x=x;
    c->y=y;
    return 0;
}

void decale(char * video)
{
    int i;
    for(i=0;i<1920;i++)
    {
	video[i]=video[i+80];
    }
    for(i=1920;i<2000;i++)
    {
	video[i]=' ';
    }
}

int putchar(int i,char ch)
{
    console * c;
    c=get_console(i);
    if (c==0) return -1;
    derniere_console_utilisee = c;
    if (ch=='\n')
    {
	if((c->y)<25) (c->y)++;
	else decale(c->video);
	c->x=1;
    }
    else
    {
	c->video[(c->x)+(c->y)*80];
	if((c->x)<80) (c->x)++;
	else
	{
	    if((c->y)<25) (c->y)++;
	    else decale(c->video);
	    c->x=1;
	}
    }
    return 0;
}

int text(int i,char* a)
{
    char * b;
    b=a;
    while(*b!=0)
    {
	if(putchar(i,*b)==-1) return -1;
	b++;
    }
    return 0;
}
