void dma(int taille, char* dest,int wr)
{
    char c;
    out(0x14,8);
    if (wr) out(0x5a,0x0b); else out(0x56,0x0b);
    c=(char)((unsigned long)dest & 0x0000FF);
    out(c,0x0c);  //reset le ship dma
    out(c,4);
    c=(char)(((unsigned long)dest & 0x00ff00)>>8);
    out(c,4);
    c=(char)(((unsigned long)dest & 0xff0000)>>16);
    out(c,0x81);
    out(c,0x0c);
    out(0xff,5);
    c=(char) ((2*taille-1) & 0xff);
    out(c,5);
    out(2,0x0a);
    out(0x10,8);
}
    
void mrqloop()
{
    while((in(0x3f4) & 0xc0) != 0x80);
}

void mrqloop2()
{
    while((in(0x3f4) & 0xc0) != 0xc0);
}   

void busyloop()
{
    while((in(0x3f4) & 0x10) == 0x10);
}

void disk_on()
{
    out(0x1c,0x3f2);
}

void disk_off()
{
    out(0,0x3f2);
}
extern char * video;

char get_current_cyl()
{
    mrqloop2();
    in(0x3f5);
    mrqloop2();
    return (in(0x3f5));
}

void set_cyl(int cyl,int tete)
{
    char c;
    mrqloop();
    out(0x0f,0x3f5);
    mrqloop();
    if(tete==1)out(0x04,0x3f5); else out(0x0,0x3f5);
    c=(char)(cyl & 0xFF);
    mrqloop();
    out(c,0x3f5);
    while((int)get_current_cyl() != cyl);
    busyloop();
}
				
    

void get_from_disk(int cyl, int sect, int tete, int taille, char* dest,char * err )
{
    char c;
    int i;
    char b[2];
    disk_on();
    set_cyl(cyl,tete);
    mrqloop();
    dma(taille,dest,0);
    mrqloop();
    out(0x66,0x3f5);
    mrqloop();
    if(tete==1)out(0x04,0x3f5); else out(0x0,0x3f5);
    mrqloop();
    c=(char)(cyl & 0xFF);
/*    convert(c,b);
    video[40]=b[0];video[42]=b[1];*/
    
    out(c,0x3f5);
    mrqloop();
    c=(char)(tete & 0xff);
/*    convert(c,b);
    video[50]=b[0];video[52]=b[1];*/
    out(c,0x3f5);
    mrqloop();
    c=(char)(sect & 0xff);
/*    convert(c,b);
    video[60]=b[0];video[62]=b[1];*/
    out(c,0x3f5);
    mrqloop();
    out(2,0x3f5);
    mrqloop();
    c=(char)(taille & 0xff);
    out(c,0x3f5);
    mrqloop();
    out(27,0x3f5);
    mrqloop();
    out(0xff,0x3f5);
    for(i=0; i<7;i++)
    {
	mrqloop2();
	err[i]=in(0x3f5);
    }
    busyloop();   
    disk_off();
}
